/*
 * physical_mem.h
 *
 * Copyright 2007, Minoru Murashima. All rights reserved.
 * Distributed under the terms of the BSD License.
 */


#ifndef physical_mem_h
#define physical_mem_h


#ifndef ASM_FILE


extern void *allocKernelPage();
extern void *allocUserPage();
extern void *allocMultiKernelPage(int);
extern void linkPhysTable(void *);
extern void unlinkPhysTable(void *);
extern uint getPhysMemSize();
extern int getAllocNum(void *);
extern int getPhysPageLinkCount(void *);
extern void setAllocNum(void *, int);
extern void enterPhysMemLock(void *);
extern void exitPhysMemLock(void *);
extern void initPhysMem();

#endif


#endif
