/*
 * init.c
 */


#include<sys/ttycom.h>
#include<unistd.h>
#include<stdio.h>
#include<stdlib.h>
#include<stropts.h>

static void runCommand(
	const char *path,
	char *argv[])
{
	pid_t pid = fork();
	if (pid == 0) {
		execv(path, argv);
		printf("failed %s!\n", path);
		exit(0);
	}
	else if (0 < pid) {
		wait(NULL);
	}
	else {
		printf("failed fork!\n");
		exit(0);
	}
}

int main()
{
	char *argv[2];
	pid_t pid;

	/* å󳫻ϡ */
	if (setsid() < 0) {
		printf("Failed setsid\n");
		return 0;
	}

	/* üμ */
	if (ioctl(0, TIOCSCTTY) < 0) {
		printf("failed ioctl!\n");
		return 0;
	}

	/* Ķͤü̾ */
	setenv("TERM","pc",1);
	
	// ǽεư
	argv[0] = "setup.sh";
	argv[1] = '\0';
	runCommand("/etc/setup.sh", argv);

	// init command
	argv[0] = "rc";
	argv[1] = '\0';
	runCommand("/etc/rc", argv);

	// exec shell.
	argv[0] = "-sh";
	argv[1] = '\0';
	execv("/sbin/bash", argv);
	printf("Can not exec shell!\n");

	return 0;
}
